=== klystrack/scancode-tool/Makefile ===
CC = gcc -s -Ic:/MinGW/include/SDL2
EXE = scancode.exe

$(EXE): scancode.c
	$(CC) -o $@ $^ -lmingw32 -lSDL2main -lSDL2
