=== debian/changelog ===
klystrack (0.20171212-2) unstable; urgency=medium

  * Upstream patch to fix building problems. (Closes: #886375)
  * Bump standards version to 4.1.3.
  * Bump debhelper version to 11.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Mon, 08 Jan 2018 09:03:36 +0100

klystrack (0.20171212-1) unstable; urgency=medium

  * Initial release (Closes: #884279)

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Tue, 12 Dec 2017 15:02:26 +0100
