=== debian/control ===
Source: klystrack
Section: sound
Priority: optional
Maintainer: Debian Multimedia Packages Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Gürkan Myczko <gurkan@phys.ethz.ch>
Build-Depends: debhelper (>= 11), libsdl2-image-dev, libsdl2-dev
Standards-Version: 4.1.3
Homepage: https://github.com/kometbomb/klystrack

Package: klystrack
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Chiptune tracker
 This is an application for creating music reminiscent of the style of music
 from 8-bit computers or, chiptunes. It features a "tracker" style sequencer,
 and a built-in synthesizer capable of a wide range sounds - including but not
 limited to basic subtractive synthesis, frequency modulation and sample
 playback. Sounds can be easily beefed up by using the effect chain. It is
 possbile to import a handful of file formats, including Protracker .MOD,
 Fasttracker 2 .XM, the Cave Story music format (.ORG) and Rob Hubbard 
 Commodore 64 SID files. Tunes can be easily exported as a single mixdown .WAV
 or separate tracks or you can simply use the playback library to use the
 klystrack files in your own games and other software.
